/**************************************************************************************
 Copyright (c) 2002 The UbixOS Project
 All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions, the following disclaimer and the list of authors.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions, the following disclaimer and the list of authors
in the documentation and/or other materials provided with the distribution. Neither the name of the UbixOS Project nor the names of its
contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Id: syscalls.h,v 1.13 2003/05/01 12:30:02 reddawg Exp $

**************************************************************************************/

#ifndef _SYSCALLS_H
#define _SYSCALLS_H

#include <ubixos/schedule.h>
#include <ubixos/file.h>

void sysGetpid();
void sysExit();
void sysExec();
void sysFork();
void sysCheckPid();
void sysGetFreePage();

void sysFwrite();
void sysFgetc();
void sysFopen();
void sysFread();
void sysFclose();
void sysFseek();
void sysMkDir();
void sysRmDir();
void sysGetUid();
void sysGetGid();
void sysSetUid();
void sysSetGid();
void sysSDE();
void sysGetDrives();
void sysGetCwd();

typedef void (*functionPTR)();

functionPTR systemCalls[] = {
  invalidCall,      /**   0 **/
  sysGetpid,        /**   1 **/
  sysExit,          /**   2 **/
  sysExec,          /**   3 **/
  sysFork,          /**   4 **/
  sysFgetc,         /**   5 **/
  sysCheckPid,      /**   6 **/
  sysGetFreePage,   /**   7 **/
  sysFopen,         /**   8 **/
  invalidCall,      /**   9 **/
  sysFclose,        /**  10 **/
  sched_yield,      /**  11 **/
  invalidCall,      /**  12 **/
  invalidCall,      /**  13 **/
  invalidCall,      /**  14 **/
  invalidCall,      /**  15 **/
  invalidCall,      /**  16 **/
  invalidCall,      /**  17 **/
  invalidCall,      /**  18 **/
  invalidCall,      /**  19 **/
  sysFopen,         /**  20 Opens A File Node       **/
  sysFclose,        /**  21 Closes A File Node      **/
  sysFread,         /**  22 File Read               **/
  sysFwrite,        /**  23 File Write              **/
  sysMkDir,         /**  24 Make Directory          **/
  sysRmDir,         /**  25 Remove Directory        **/
  sysGetCwd,        /**  26 Get Current Working Dir **/
  sysFseek,         /**  27 Set FD Position         **/
  invalidCall,      /**  28 **/
  invalidCall,      /**  29 **/
  invalidCall,      /**  30 **/
  sysGetUid,        /**  31 Get User Id          **/
  sysGetGid,        /**  32 Get Group Id         **/
  sysSetUid,        /**  33 Set User Id          **/
  sysSetGid,        /**  34 Set Group Id         **/
  invalidCall,      /**  35 **/
  invalidCall,      /**  36 **/
  invalidCall,      /**  37 **/
  invalidCall,      /**  38 **/
  invalidCall,      /**  39 **/
  sysSDE,           /**  40 SDE Kernel Interface **/
  invalidCall,      /**  41 **/
  invalidCall,      /**  42 **/
  invalidCall,      /**  43 **/
  invalidCall,      /**  44 **/
  sysGetDrives,     /**  45 Get Drives           **/      
  };

int totalCalls = sizeof(systemCalls)/sizeof(functionPTR);

#endif

